# coding: utf8

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import calendar, time

class DateTime:
    def __init__(self, t=None, date=None):
        if t != None:
            self.time = t
        elif date:
	    date = date.replace(':', '')
	    date = date.replace('-', '')
            if len(date) > 9:
                hour = int(date[9:11])
		minute = int(date[11:13])
                date = date[:8]
            else:
                hour, minute = 0, 0
            year = int(date[0:4])
            month = int(date[4:6])
            day = int(date[6:8])
            self.time = time.mktime((year, month, day, hour, minute, 0, 0, 0, -1))
        else:
            self.time = time.time()
    def __str__(self):
        return time.strftime('%c', time.localtime(self.time))
    def __cmp__(self, other):
        return cmp(self.time, other.time)
    def __getattr__(self, attr):
        t = time.localtime(self.time)
	year, mon, mday, hour, min, sec, wday = t[:7]
        if attr == 'ddmmyyyy':
            return '%02d/%02d/%04d' % (mday, mon, year)
        elif attr == 'ddmm':
            return '%02d/%02d/%04d' % (mday, mon)
        elif attr == 'yyyymmdd':
            return '%04d-%02d-%02d' % (year, mon, mday)
        elif attr == 'hhmmss':
            return '%02d:%02d:%02d' % (hour, min, sec)
        elif attr == 'hhmm':
            return '%02d:%02d' % (hour, min)
        elif attr == 'hms':
            return '%02dh%02dm%02ds' % (hour, min, sec)
        elif attr == 'dmy':
            month = calendar.month_name[mon][:3]
            return '%d %s %d' % (mday, month, year)
        elif attr == 'mday':
            return mday
        elif attr == 'month':
            return mon
        elif attr == 'monthname':
            return calendar.month_name[mon]
        elif attr == 'year':
            return year
        else:
            raise AttributeError, attr

