#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.context import register_obj
from pythonite.utils import log

dbcache = {}

class Database:
    def __init__(self, arg, req):
        self.arg = arg
        self.req = req
	self.db = None
    def connect(self):
        import MySQLdb
	if not self.db:
	    opt = self.req.option
	    log(1, 'DB connect '+opt.dbname)
	    try:
	        self.db = dbcache[opt.dbname, opt.dbuser, opt.dbpass]
	    except KeyError:
	        self.db = dbcache[opt.dbname, opt.dbuser, opt.dbpass] = MySQLdb.connect(db=opt.dbname, user=opt.dbuser, passwd=opt.dbpass)
	    self.cursor = self.db.cursor()
    def execute(self, sql):
	self.connect()
        return DatabaseTable(self.cursor, '', sql)
    def __getattr__(self, attr):
        if attr[0] == '_':
	    raise AttributeError, attr
	self.connect()
	log(1, 'DB getattr '+attr)
	return DatabaseTable(self.cursor, attr)

class DatabaseTable:
    def __init__(self, cursor, name, sql=''):
        self.cursor = cursor
	self.name = name
	self.sql = sql or 'select * from '+name
    def __iter__(self):
        log(1, 'dt iter '+self.name)
        self.cursor.execute(self.sql)
	self.map = {}
	i = 0
	for desc in self.cursor.description:
	    self.map[desc[0]] = i
	    i += 1
        log(1, 'dt map %s' % repr(self.map))
        return self
    def next(self):
        log(1, 'dt next')
        try:
            rec = self.cursor.fetchone()
	except:
	    raise StopIteration
	if not rec:
	    raise StopIteration
        return DatabaseRecord(self.map, rec)

class DatabaseRecord:
    def __init__(self, map, rec):
        self.map = map
        self.rec = rec
    def __getattr__(self, attr):
	try:
	    i = self.map[attr]
	except KeyError:
	    raise AttributeError, attr
	return self.rec[i]

register_obj('database', Database, 'None')
