#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.context import register_ext
from pythonite.utils import log
import os, sys

class Script:
    objtype = 'script'
    def __init__(self, path, context):
        self._path = path
        self._context = context
        dir = os.path.dirname(path)
        if not dir in sys.path:
            sys.path.insert(0, dir)
        log(1, 'importing '+path)
        name = os.path.basename(path)
        name, ext = os.path.splitext(name)
        self._script = reload(__import__(name))
    def __getattr__(self, attr):
        if attr[0] == '_':
            raise AttributeError, attr
        return getattr(self._script, attr)

register_ext('.py', Script)
