#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from mod_python import apache, util
from pythonite.core import handle_request
from pythonite import config
import os

def document_root(req):
    """ get document root from config file """
    try:
        conf = open(req.server.defn_name)
    except IOError:
        return '/web'
    lines = conf.readlines()
    linenum = req.server.defn_line_number - 1
    for line in lines[linenum:]:
        word = line.split()
        if len(word) == 2 and word[0] == 'DocumentRoot':
            return word[1]
    return '/'

def handler(req):
    """ http request handler called by apache """
    if not req.uri.endswith(config.extension):
        return apache.DECLINED
    req.rootdir = document_root(req)
    req.fields = util.FieldStorage(req, keep_blank_values=1).list
    req.status = 200
    data = handle_request(req)
    for err in req.errors:
        data += '<!-- '+err+' -->\n'
    req.headers_out['Content-length'] = str(len(data))
    req.send_http_header()
    req.write(data)
    return apache.OK

